package heap;

// The heapsort algorithm - class IntNode.
// This implementation is modeled after the courseware Heapsort-SALA.
// http://OLLI.Informatik.Uni-Oldenburg.DE/heapsort_SALA/
// It is optimized for easy understanding and not for efficiency.
// (c) 2001 Nils Faltin. Distributed under the GNU General Public License. 
// The license text ist contained in the courseware distribution.

// used by class HeapArray
// a Node as stored in the heaptree or the result list
class DoubleNode extends Node{
	
  public double key; // sorting key
  public Object object;
  
  public DoubleNode(double key, Object object){
    this.key = key;
	this.object = object;
  }
  
  public boolean isGreaterThan(Node b){
    return key > ((DoubleNode)b).key;
  }
  
  public String toString(){
    return String.valueOf(key);
  }
}
