package heap;


// A Priority Queue using a Heap Tree - class PriorityQueue.

// This implementation is modeled after the courseware Heapsort-SALA.
// http://OLLI.Informatik.Uni-Oldenburg.DE/heapsort_SALA/
// It is optimized for easy understanding and not for efficiency.
// (c) 2001 Nils Faltin. Distributed under the GNU General Public License. 
// The license text ist contained in the courseware distribution.


// Implements a Priority Queue using a heap tree
public class PriorityQueue extends HeapArray {  
 
	// class methods
   // constructor: initialize with empty array of length len
	public PriorityQueue(int len){
	  super(len);
	}
	
	
	
	
	
	public void enqueue(Object object, double priority){
		addNode(new DoubleNode(priority, object));
	}
	public Object dequeue(){
		DoubleNode node = (DoubleNode)getMaxNode();
		if (node == null)
			return null;
		return node.object;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
  // instance methods
  
   // algorithm functions
    
    //add a Node
    public void addNode(Node n){
      super.addNode(n);
      flowUp(lastHeap); 
    }

	// get and remove maximum Node. If Queue is empty, Return null.
	public Node getMaxNode(){
	  if (heapEmpty()) 
	    return null;
	  Node maxNode = getNodeAt(moveMax()) ;
	  decrementArraysize();
	  return maxNode;
	}

    // Move up a key untill it satisfies the heaporder
    protected void flowUp(int k) {
	// swap the key at k with its parents along the path to the root until it finds the place, where the heaporder is fulfilled.
      while (parent(k) != nullIndex && isGreaterThan(k, parent(k))){
        swap(parent(k),k);
        k = parent(k);
      }
    }
}
